
# WtrOnlineIOS

iOS配网插件 原生Objec-C代码编写

## Getting Started

初始化并开始扫描设备
```
[[ICBleManager shared] initService];
[[ICBleManager shared] beginScanPeripherals];
[ICBleManager shared].deviceFoundBlock = ^(NSArray<ICDeviceModel *> *modelList) {
    self.deviceList = modelList.mutableCopy;
    [self.tableView reloadData];
};
```

取消扫描
```
[[ICBleManager shared] cancelScan];
```

连接设备

```
/** 设置代理 */
[ICBleManager shared].connectDelegate = self;

/** 连接设备  */
[[ICBleManager shared] connectPeripheral:self.currPeripheral];

```

开始配网

```
[[ICBleManager shared] startConfigNetwork:wifiName password:password]
```

回调各种状态

```
#pragma mark - ICBleConnectDelegate
/** 连接失败的回调 */
- (void)onConnectedFail:(CBPeripheral *)peripheral
{
    [WSProgressHUD dismiss];
    [ICToast showWithText:@"连接失败"];
    [self commonBackMainVC];
}

/** 连接断开的回调 */
- (void)onDisconnected:(CBPeripheral *)peripheral
{
    [WSProgressHUD dismiss];
    [ICToast showWithText:@"已断开连接"];
    [self commonBackMainVC];
}

/** 配网结果 */
- (void)onReceiveConfigNetworkResult:(BOOL)isSuccess
{
    [WSProgressHUD dismiss];
    
    if(isSuccess)
    {              
        [self commonBackMainVC];
        [ICToast showWithText:@"配网成功"];
    }
    else
    {
        [ICToast showWithText:@"配网失败"];
    }
}
```

More - 获取wifi名称

```
//定位服务
@property(nonatomic,strong) ICLocationUtils *locationUtils;

//请求wifi名称
[self.locationUtils requireWifiName];

- (ICLocationUtils *)locationUtils
{
    if(_locationUtils == nil)
    {
        _locationUtils = [[ICLocationUtils alloc] init];
        _locationUtils.delegate = self;
    }
    return _locationUtils;
}

#pragma mark - ICLocationUtilsDelegate
- (void)receiveWifiName:(NSString *)wifiName
{
    self.wifiNameTF.text = wifiName;
}
```

