//
//  ICDeviceListCell.m
//  iosCalibrateDemo
//
//  Created by waytronic on 2024/9/11.
//

#import "ICDeviceListCell.h"

@interface ICDeviceListCell ()

@property(nonatomic,strong) UILabel *titleLabel;

@end

@implementation ICDeviceListCell

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self)
    {
        self.selectionStyle = UITableViewCellSelectionStyleNone;
        
        self.titleLabel = self.contentView.addLabel(1)
            .textColor(UIColorFromRGB(0x333333))
            .font([UIFont systemFontOfSize:16])
            .masonry(^ (UILabel *label, MASConstraintMaker *make) {
                make.left.equalTo(self.contentView).offset(20);
                make.centerY.equalTo(self.contentView);
            })
            .view;
        
        
        self.contentView
            .addImageView(2)
            .image([UIImage imageNamed:@"icon_right_access"])
            .masonry(^(__kindof UIView *sender, MASConstraintMaker *make) {
                make.right.equalTo(self.contentView).offset(-20);
                make.centerY.equalTo(self.contentView);
                make.width.height.equalTo(@24);
            });
        
        self.contentView
            .addView(3)
            .backgroundColor(UIColorFromRGB(0xF0F0F0))
            .masonry(^(__kindof UIView *sender, MASConstraintMaker *make) {
                make.left.equalTo(self.contentView).offset(20);
                make.bottom.equalTo(self.contentView);
                make.centerX.equalTo(self.contentView);
                make.height.mas_equalTo(1);
            });
    }
    return self;
}

- (void)setDeviceModel:(ICDeviceModel *)deviceModel {
    _deviceModel = deviceModel;
    self.titleLabel.text = deviceModel.blueName;
}

@end
