//
//  ICEnum.h
//  WtrOnlineIOSDemo
//
//  Created by waytronic on 2024/9/20.
//

#ifndef ICEnum_h
#define ICEnum_h

#pragma mark - 枚举

/** 设备相关类型  */
typedef NS_ENUM(int,ICBleDeviceInfoKey){
    ICBleDeviceInfoKeyType,
    ICBleDeviceInfoKeyMac,
    ICBleDeviceInfoKeyVersion,
    ICBleDeviceInfoKeyBuild,
    ICBleDeviceInfoKeyPlus
};

/** 设备类型  */
typedef NS_ENUM(int,ICDeviceInfoType){
    ICDeviceInfoTypeUnknow,
    ICDeviceInfoTypeOnline,
    ICDeviceInfoTypeWTFC,
    ICDeviceInfoTypeBleTTS,
    ICDeviceInfoTypeOnlineTTS,
};

/** 设备网络类型  */
typedef NS_ENUM(int,ICBleDevicePlus){
    ICBleDevicePlusBleOnly = 1,
    ICBleDevicePlusWifi,
    ICBleDevicePlusFourG,
};


/** 固定协议的发送数据结构  */
struct __attribute__((packed)) ICSendData
{
    uint8_t head;
    uint16_t len;
    uint8_t serialId;
    uint8_t ack;
    uint8_t source;
    NSData *data;
    uint8_t check;
    uint8_t end;
};


struct __attribute__((packed)) ICResultData
{
    int head;
    int len;
    int serialId;
    int ack;
    int source;
    int keyID;
    int datalen;
    NSData *data;
    int check;
    int end;
};

// 定义一个标志来表示结构体为空
static const struct ICResultData IC_RESULT_NULL = {-1,-1,-1,-1,-1,-1,-1,nil,-1,-1};

static inline BOOL icIsEqualResultData(struct ICResultData data1, struct ICResultData data2) {
    return data1.head == data2.head &&
           data1.len == data2.len &&
           data1.serialId == data2.serialId &&
           data1.ack == data2.ack &&
           data1.source == data2.source &&
           data1.keyID == data2.keyID &&
           data1.datalen == data2.datalen &&
           (data1.data == data2.data || [data1.data isEqualToData:data2.data]) &&
           data1.check == data2.check &&
           data1.end == data2.end;
}

#endif /* ICEnum_h */
